<?php
// wbb imports
require_once(WBB_DIR.'lib/data/post/ViewablePost.class.php');
require_once(WBB_DIR.'lib/data/thread/ViewableThread.class.php');
require_once(WBB_DIR.'lib/data/boxes/PortalBox.class.php');
require_once(WBB_DIR.'lib/data/boxes/StandardPortalBox.class.php');

/**
 * This box shows the latest news
 *
 * @package	com.woltlab.community.portal.news
 * @author	WoltLab Community
 * @copyright	2009 WoltLab Community
 * @license	GNU Lesser Public License <http://www.gnu.org/licenses/lgpl.html>
 * @subpackage	data.boxes
 * @category	Portal
 */
class NewsBox extends PortalBox implements StandardPortalBox {
	public $stylesheet = 'news';
	public $news = array();

	/**
	 * @see StandardPortalBox::readData()
	 */
	public function readData() {
		$attachmentPostIDArray = array();
		foreach ($this->cacheData as $newsRow) {
			$thread = new ViewableThread(null, $newsRow);
			$post = new ViewablePost(null, $newsRow, $thread);
			// attachments
			if ($newsRow['attachments'] != 0) {
				$attachmentPostIDArray[] = $newsRow['postID'];
			}
			$this->news[] = $post;
		}
		$this->news = array_slice($this->news, 0, NEWSBOX_NEWSITEMS);

		if (!count($this->news)) $this->empty = true;

		// read attachments
		if (MODULE_ATTACHMENT == 1 && count($attachmentPostIDArray) > 0) {
			require_once(WCF_DIR.'lib/data/attachment/MessageAttachmentList.class.php');
			$attachmentList = new MessageAttachmentList($attachmentPostIDArray, 'post');
			$attachmentList->readObjects();
			$attachments = $attachmentList->getSortedAttachments(true);

			// set embedded attachments
			require_once(WCF_DIR.'lib/data/message/bbcode/AttachmentBBCode.class.php');
			AttachmentBBCode::setAttachments($attachments);
		}

		foreach ($this->news as &$post) {
			$post->textCut = false;
			if (empty($post->messageCache)) {
					$post->messageCache = $post->getFormattedMessage();
			}
			if (NEWSBOX_LENGTH != -1) {
				if (StringUtil::length(StringUtil::stripHTML($post->messageCache)) > NEWSBOX_LENGTH) {
					// message is too long and hast to be truncated
					$post->messageCache = HTMLUtil::truncateHTML($post->messageCache, NEWSBOX_LENGTH);
					$post->textCut = true;
				}
			}
		}
	}

	/**
	 * @see StandardPortalBox::getTemplateName()
	 */
	public function getTemplateName() {
		return 'newsbox';
	}
}
?>