<?php
require_once(WCF_DIR.'lib/data/user/User.class.php');
require_once(WCF_DIR.'lib/system/cache/CacheBuilder.class.php');

/**
 * Caches the latest news
 *
 * @package		com.woltlab.community.portal.news
 * @author		WoltLab Community
 * @copyright	2009 WoltLab Community
 * @license		GNU Lesser Public License <http://www.gnu.org/licenses/lgpl.html>
 * @subpackage	system.cache
 * @category	Portal
 */
class CacheBuilderNews implements CacheBuilder {
	/**
	 * @see CacheBuilder::getData()
	 */
	public function getData($cacheResource) {
		if (NEWSBOX_BOARDID == '') return array();
		
		$data = array();
		$boardIDs = NEWSBOX_BOARDID;
		$limit = NEWSBOX_NEWSITEMS;
		
		// determine limit
		if (defined('COMPACTNEWS_NEWS_ITEMS')) {
			$limit = max(COMPACTNEWS_NEWS_ITEMS, $limit);
		}
		
		// TODO: Unterstützung für Mehrsprachigkeit hinzufügen
		$sql = "SELECT		post_cache.messageCache,
					post.*,
					thread.*,
					board.title,
					board.boardID
                	FROM		wbb".WBB_N."_post post
			LEFT JOIN	wbb".WBB_N."_thread thread
			ON		(post.threadID = thread.threadID)
			LEFT JOIN	wbb".WBB_N."_board board
			ON		(thread.boardID = board.boardID)
			LEFT JOIN	wbb".WBB_N."_post_cache post_cache
			ON		(post_cache.postID = post.postID)
			WHERE		thread.boardID IN(".$boardIDs.")
			AND		thread.isDisabled = 0
			AND		thread.isDeleted = 0
			AND		thread.movedThreadID = 0
			GROUP BY	post.postID HAVING thread.firstPostID = post.postID
			ORDER BY	post.time DESC
			LIMIT		".$limit;
		$result = WCF::getDB()->sendQuery($sql);
		
		while ($row = WCF::getDB()->fetchArray()) {
			$data[] = $row;   
		}
		
		return $data;
	}
}
?>